# Simple 

You can run this wole thing through the driver, ```HamletSans.py```

The whole deal is a two-step process.

## The Text Files

There are several text files in the ```poems/``` directory. Each text file is represented by a single 
bot. The bot accounts were created ahead of time, by hand, as part of 
the one-time account generation process.

## Step 1: (One-Time) Key Generation Process

Keys that allow an app to tweet as a Twitter account require a one-time generation 
of a set of keys.

Create Twitter authorization URLs for visitors to visit and obtain a PIN number
to create credentials. This is what allows the application to masquerade as 
one of the bots.

This is done by the Keymaster. 

### The Keymaster

The Keymaster goes through each text file and asks if you want to create a key associated with that poem.
(That is, a key associated with a bot that owns that text file.)

If you decide to create a key, the Keymaster creates a custom Twitter authorization URL.
You then log in as the bot, visit that link, and grant permission for the Python application
to use your account by giving the PIN number that shows up when you click hte link.

The ability for the app to tweet using that account is dependent on its having the right keys.
The app needs an app-specific key (the consumer token) and a user-specific key (the authorization token).
Then the app can tweet as any user that's granted permission for the app to do so.

That information is stored in a JSON file in the ```keys/``` folder.

## Step 2: Run the Bot Army

### The Sheep 

These, obviously, are the bots. 

One Sheep is tied to one Twitter account, and can tweet one poem.

### The Shepherd

The Shepherd is a single controller that creates and manages the flock of Sheep.
The Shepherd decides the schedule, tells Sheep when to tweet and when to sleep,
and decides... other stuff.

## Simple Shepherd

Simple Shepherd has one "setup()" function.

## Simple Sheep

Simple Sheep keep it simple. All they do is
interface with Twitter, tweet, and keep track 
of their age.

## Keymaker

The keymaker handles the OAuth authentication
with Twitter. It generates the public/private
access token that is required for a Sheep to 
tweet.
