import urlparse
import oauth2 as oauth
import os
import time
import re
import simplejson as json
from poster.encode import multipart_encode
from poster.streaminghttp import register_openers
import urllib2
import httplib

from apikeys import *

"""
Ring

Loads a set of JSON keys into memory,
performs collective 
account actions
on ginsberg bot flock 
accounts.
"""

# Register the streaming http handlers with urllib2
# http://stackoverflow.com/questions/680305/using-multipartposthandler-to-post-form-data-with-python
register_openers()
            

class Ring(object):
    def __init__(self,keys_dir):

        self.keys_dir = keys_dir

        raw_files = os.listdir(keys_dir)

        # all_json is the list of all 
        # JSON files from which we'll
        # grab key info (to perform
        # group operations)
        all_json = []
        for rfile in raw_files:
            if rfile[-5::]=='.json':
                all_json.append(rfile)

        self.all_json = all_json
        
        # all_keys is a list of dictionaries
        # that contain the bundle of bot info
        # stored in each JSON file
        all_keys = []
        for jsonf in all_json:
            full_jsonf = keys_dir + jsonf
            print "Loading key in json file "+full_jsonf
            with open(full_jsonf, "r") as f:
                all_keys.append( json.load(f) )

        self.all_keys = all_keys

    def get_keys(self):
        """
        Returns a list of dictionaries
        containing key info for each bot
        """
        return self.all_keys





    def change_profile(self):

        for key_dictionary in self.all_keys:

            ########################################
            # This page:
            # http://stackoverflow.com/questions/14836956/how-to-get-user-image-with-twitter-api-1-1
            # shows a get request.
            # I think you gotta combine get and post methods.
            # api.twitter.com/api/something.json/url?screen_name=charlesreid1
            #
            #
            # Close. You have to sign a POST request,
            # then turn it into a regular GET request.
            # (Apparently...?)
            # 
            # This gist:
            # https://gist.github.com/velocityzen/1242662
            # This SO thread:
            # http://stackoverflow.com/questions/6924569/doing-a-file-upload-with-python-oauth2
            #
            # This SO thread did it:
            # http://stackoverflow.com/questions/12977604/how-do-i-send-a-post-using-2-legged-oauth2-in-python
            # Boom.
            # Twitter expects body to be a JSON
            # containing whatever parameters are listed 
            # on the Twitter API documentation.
            ########################################

            handle = key_dictionary['screen_name']

            handle2title = {}
            handle2title['gbf_america'] = 'America'
            handle2title['gbf_howl'] = 'Howl'
            handle2title['gbf_supermarket'] = 'A Supermarket in California'
            handle2title['gbf_organ'] = 'Transcription of Organ Music'
            handle2title['gbf_greyhound'] = 'In a Baggage Room at Greyhound'
            handle2title['gbf_sunflower'] = 'Sunflower Sutra'
            handle2title['gbf_elegy'] = 'Elegy Che Guevara'
            handle2title['gbf_dc'] = 'D.C. Mobilization'

            gbf_url = 'http://charlesreid1.github.io/imaginary-friends#ginsberg'
            gbf_descr = "Member of the Ginsberg Bot Flock. Tweeting Allen Ginsberg's poem \""+handle2title[handle]+"\" forever."

            # -------------------

            # Set the API endpoint 
            url = "https://api.twitter.com/1.1/account/update_profile.json"

            import urllib

            token = oauth.Token(key = key_dictionary['oauth_token'], 
                             secret = key_dictionary['oauth_token_secret'])
            consumer = oauth.Consumer(key = key_dictionary['consumer_token'], 
                                   secret = key_dictionary['consumer_token_secret'])
            client = oauth.Client(consumer,token)
            resp, content = client.request(
                    url,
                    method = "POST",
                    body=urllib.urlencode({'url': gbf_url,
                                           'description': gbf_descr}),
                    headers=None
                    )
            
            print content




    def change_photo_request(self):
        """
        Send a request to change each bot's profile photo
        """
        for key_dictionary in self.all_keys:

            # Set the API endpoint 
            #url = "https://api.twitter.com/1.1/account/update_profile_image.json"
            url = "https://api.twitter.com/1.1/account/update_profile_image.json"

            import urllib

            ### #------------------------------
            ### # Alt 1:

            ### token = oauth.Token(key = key_dictionary['oauth_token'], 
            ###                  secret = key_dictionary['oauth_token_secret'])
            ### consumer = oauth.Consumer(key = key_dictionary['consumer_token'], 
            ###                        secret = key_dictionary['consumer_token_secret'])
            ### client = oauth.Client(consumer,token)

            ### # Parameters:
            ### # Set the base oauth_* parameters along with any other parameters required
            ### # for the API call.
            ### params = {
            ###     'oauth_version': "1.0",
            ###     'oauth_nonce': oauth.generate_nonce(),
            ###     'oauth_timestamp': int(time.time()),
            ###     'user': key_dictionary['screen_name'],
            ### }
            ### #    'image':'http://d.gr-assets.com/authors/1206649831p5/4261.jpg'

            #------------------------------
            # Alt 2:

            # Set up instances of our Token and Consumer. The Consumer.key and 
            # Consumer.secret are given to you by the API provider. The Token.key and
            # Token.secret is given to you after a three-legged authentication.
            token = oauth.Token(key = key_dictionary['oauth_token'], 
                             secret = key_dictionary['oauth_token_secret'])
            consumer = oauth.Consumer(key = key_dictionary['consumer_token'], 
                                   secret = key_dictionary['consumer_token_secret'])
            client = oauth.Client(consumer,token)
            resp, content = client.request(
                    url,
                    method = "POST",
                    body=urllib.urlencode({'image': open('ginsberg.jpg','rb')}),
                    headers=None
                    )
            
            print content





    def change_photo_request2(self):
        for key_dictionary in self.all_keys:
            # Set the API endpoint 
            domain = "https://api.twitter.com"
            url = domain+"/1.1/account/update_profile_image.json"

            import urllib

            token = oauth.Token(key = key_dictionary['oauth_token'], 
                             secret = key_dictionary['oauth_token_secret'])
            consumer = oauth.Consumer(key = key_dictionary['consumer_token'], 
                                   secret = key_dictionary['consumer_token_secret'])
            client = oauth.Client(consumer,token)

            req = oauth.Request.from_consumer_and_token(
                    consumer, 
                    token=token, 
                    http_url=url,
                    parameters=None, 
                    http_method="POST")
            req.sign_request(oauth.SignatureMethod_HMAC_SHA1(), consumer, token)


            # Generate multipart data and headers from content
            datagen, headers = multipart_encode({'image': open('ginsberg.jpg','rb')})


            # Append OAuth Authorization headers to generated headers
            headers.update(req.to_header())

            # Body to string
            body = "".join(datagen)

            # Create the Request object
            request = urllib2.Request(url, datagen, headers)
            print urllib2.urlopen(request).read()








            # I'm using httplib here. urllib2 should be possible as well
            #conn = httplib.HTTPSConnection(domain)
            #conn.request("POST", req.get_url_location, body, headers)
            #response = conn.getResponse()
            ## result
            #print response.read()


            ### # create our request
            ### url_params = {}
            ### url_params['body'] = {'image': open('ginsberg.jpg','rb')}
            ### datagen, headers = multipart_encode(url_params)

            ### for dat,head in zip(datagen,headers):
            ###     resp, content = client.request(
            ###             url,
            ###             method = "POST",
            ###             body = dat,
            ###             headers = head
            ###             )

            ### print content

            '''
            # via python-oauth2/example/client.py
            # create our request
            req = oauth.Request.from_consumer_and_token(
                                        consumer, 
                                        token=token, 
                                        http_method='POST', 
                                        http_url=url, 
                                        parameters=params)
            # sign our request
            req.sign_request(oauth.SignatureMethod_HMAC_SHA1(), consumer, token)

            # reassemble post data with oauth token for authorization
            postdata = req.to_postdata()
            url_params = urlparse.parse_qs(postdata,keep_blank_values=True)
            for key, val in url_params.iteritems():
                url_params[key] = val[0]

            url_params['body'] = {'image': open('ginsberg.jpg','rb')}
            datagen, headers = multipart_encode(url_params)

            # Now that we have a POST request signed by Twitter,
            # form a regular old Request
            request = urllib2.Request(url, datagen, headers)

            print "Trying to submit profile photo change request for bot "+key_dictionary['screen_name']

            try:
                respdata = urllib2.urlopen(request).read()
            except urllib2.HTTPError, ex:
                err = 'Received error code: ', ex.code
                raise Exception(err)
 
            print self.parse_response(respdata)

            a = 0
            '''


if __name__=="__main__":
    r = Ring('keys/')
    r.change_photo_request2()

