import time
import os
import re
import json

from Keymaker import *
from SimpleSheep import *

def runsheep(sheeeep):
    sheeeep.loop()

class SimpleShepherd(object):
    """
    Startup:
        Shepherd invokes one Keymaker
        Shepherd looks for poems
        Shepherd asks Keymaker for one key per poem
        Keymaker generates an oauth token and link
        User visits link while logged in 
        User grants permission to app and gets PIN
        User gives PIN to Keymaker
        Keymaker generates authorization tokens for API
        Shepherd dumps bundle into JSON file - 1 JSON per sheep 
            - auth key, auth token
            - user id, user handle
            - poem file

    Loop:
        Shepherd loops through the flock
        Tell sheep to tweet
    """
    def __init__(self):
        self.all_json = []
        self.all_sheep = []



    def setup(self,json_key_dir,line_interval=30,poem_interval=(1.5*3600)):
        """
        Assume keys have been created,
        and that we didn't make them
        """
        self.line_interval = line_interval
        self.poem_interval = poem_interval

        raw_files = os.listdir(json_key_dir) 
        for rfile in raw_files:
            if rfile[-5:] == '.json':
                full_filename = re.sub('//','/',json_key_dir + '/' + rfile)
                self.all_json.append(full_filename)

        for jsonf in self.all_json:
            print "Making Sheep for file "+jsonf
            mysheep = SimpleSheep(jsonf,
                        line_interval=self.line_interval,
                        poem_interval=self.poem_interval)
            self.all_sheep.append(mysheep)


    def loop(self):
        """
        This is what the Shepherd does...
        forever
        """
        pool = ThreadPool(len(self.all_sheep))

        results = pool.map(runsheep,self.all_sheep)



    def say_cheese(self):
        """
        Change every bot's photo
        """
        for sheep in self.all_sheep:
            sheep.say_cheese()



    def jonestown(self):
        """
        All of our sheep will undergo a mass collective 
        history wipe
        """
        for sheep in self.all_sheep:
            print "Performing a lobotomy for sheep "+sheep.params['screen_name']
            sheep.lobotomy()

